package test;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ExtensibleURIConverterImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.resources.util.UMLResourcesUtil;

public class Test {

	private static final ResourceSet RESOURCE_SET;
	private static final ExtensibleURIConverterImpl converter = new ExtensibleURIConverterImpl();

	private static final URI ulModel = URI.createURI("MyModel.uml");
    private static final URI upModel = URI.createFileURI("model/MyModel.uml");

	private static final URI ulProfile = URI.createURI("MyModel.profile.uml");
    private static final URI upProfile = URI.createFileURI("model/MyModel.profile.uml");
    
	static {
		RESOURCE_SET = new ResourceSetImpl();
		UMLResourcesUtil.init(RESOURCE_SET);

		converter.getURIMap().put(ulModel, upModel);
		converter.getURIMap().put(ulProfile, upProfile);
	}
    
	public static void main(String[] args) {
		Model model = (Model)RESOURCE_SET.getResource(converter.normalize(ulModel), true).getContents().get(0);
		Profile profile = (Profile)RESOURCE_SET.getResource(converter.normalize(ulProfile), true).getContents().get(0);
		profile.define();
		model.applyProfile(profile);

		Class myClass = (Class) model.getOwnedType("My Class");
		Property myProperty = (Property) myClass.getOwnedAttribute("My Attribute", null);

		Stereotype s = profile.createOwnedStereotype("My Stereotype", false);
		myProperty.applyStereotype(s);
	}

}
